      subroutine REP_BOUND(ndim,melem,nelem,mpoin,npoin,
     *     maxdeg,x,y,lnd,iae,
     *     ra,icyc,rminerr,imin,rmaxrez,
     *     icha,nserr,wp,rga,rgb,rgc,lbn,itc,ibc,nbelm,mbelm,
     *     ipoint,nbp,xb,yb,ibb,ibpoin,ibp)
      dimension lnd(melem,3),iae(melem,3),x(mpoin),y(mpoin),
     *     ra(mpoin),wp(mpoin,ndim+1),lbn(mbelm,2),
     *     itc(mbelm),ibc(mbelm),
     *     icyc(mpoin,maxdeg),
     *     nserr(melem*3,2),rga(mpoin),rgb(mpoin),rgc(mpoin),
     *     xb(ipoint),yb(ipoint),ibp(mpoin),ibb(mpoin,2),ibpoin(0:nbp)
      integer lock(20)
      real xx(4),yy(4),rmax(3),jmax(3)
      real*8 x0,y0,x1,y1,x2,y2,det,rll,rl0,rl1,rl2,rlen0,
     *     rlen1,rlen2,rd,reps,det123,xx1,yy1,xx2,yy2
      common /const/ p, epsilon1, pos, numel,ityp
      common /period/ xper,yper,iper1,iper2


      icha = 0
      nelemold = nelem
      ipoc = 1
      do 10 iyi=1,nelemold
         i = ipoc
         do 20 j=1,3
            if(iae(i,j) .lt. 0) then
               j1 = mod(j,3) + 1
               j2 = mod(j1,3) + 1
               k1 = lnd(i,j)
               if(ibb(k1,1) .gt. 0) then 
                  ikk1 = ibb(k1,2)
                  if(ibb(k1,1) .eq. ibpoin(ikk1-1)+1  .or.
     *                  ibb(k1,1) .eq. ibpoin(ikk1)) then
c               NO moving of final or initial node of profiles
                     goto 21
                  endif
               endif
               k2 = lnd(i,j1)
               k0 = lnd(i,j2)
               x1 = x(k1)
               y1 = y(k1)
               x2 = x(k2)
               y2 = y(k2)
               x0 = x(k0)
               y0 = y(k0)

               if(ibb(k1,1) .gt. 0 .and. ibb(k2,1) .gt. 0 )then
c     we seek the point in the field [xb(i),yb(i)] i=1,ipoint
                  det = x0*(y1-y2) + x1*(y2-y0) + x2*(y0-y1)
                  rll = ((x(k1) - x(k2))*(x(k1) - x(k2)) +
     *                 (y(k1) - y(k2))*(y(k1) - y(k2)) )
                  rd = det/(rll**0.5)
               
                  rl0 = 1E+35
                  do 30 ll1=1,ipoint
                     rlen0 = (x0 -xb(ll1))*(x0 -xb(ll1)) + 
     *                    (y0 -yb(ll1))*(y0 -yb(ll1))
                     if(rlen0 .lt. rl0) then
                        rl0 = rlen0
                        il0 = ll1
                     endif
 30               continue
                  il1 = ibb(k1,1)
                  il2 = ibb(k2,1)
                  rlen1 = (x1 -xb(il1))*(x1 -xb(il1)) + 
     *                 (y1 -yb(il1))*(y1 -yb(il1))
                  rlen2 = (x2 -xb(il2))*(x2 -xb(il2)) + 
     *                 (y2 -yb(il2))*(y2 -yb(il2))

                  if(il1 .eq. il0 .or. il2 .eq. il0) then
                     goto 20
                  endif
                  
c     to verify: il0 must be between il1 and il2
                  if( ( il0 .gt. il1 .and. il0 .gt. il2) .or.
     *                 ( il0 .lt. il1 .and. il0 .lt. il2)) goto 20

                  if(rl0**0.5 .lt. 0.45*rd .and. icyc(k0,1) .gt. 0) then
c     this is a candidate, we check the positivity
                     do 40 kk=1,icyc(k0,1)
                        if(icyc(k0,kk+1) .ne. k1) then
                           kk1 = mod(kk,icyc(k0,1)) + 1
                           xx1 = x(icyc(k0,kk+1))
                           yy1 = y(icyc(k0,kk+1))
                           xx2 = x(icyc(k0,kk1+1))
                           yy2 = y(icyc(k0,kk1+1))
                           reps = pos*( ((x0-xx2)**2 + (y0-yy2)**2) +
     *                          ((xx1-xx2)**2 + (yy1-yy2)**2) +
     *                          ((x0-xx1)**2 + (y0-yy1)**2) )
                           det123 = x0*(yy1-yy2) + xx1*(yy2-y0) + 
     *                          xx2*(y0-yy1) 
                           if( det123 .le. reps) then
c     violation of positivity, go to next i
                           print *,'violation of positivity in REMOVE'
                              goto 20
                           endif
                        endif
 40                  continue

c     we remove this triangle
                     if(icyc(k1,1) .gt. 0 .or. icyc(k2,1) .gt. 0) then
                        print *,'very divny in REP_BOUN'
                        stop
                     endif

                     x(k0) = xb(il0)
                     y(k0) = yb(il0)
                     ibb(k0,1) = il0
                     do ll=1,nbp
                        if(il0 .ge. ibpoin(ll-1) +1 .and.
     *                       il0 .le. ibpoin(ll) ) then
                           ibb(k0,2) = ll
                           goto 109
                        endif
                     enddo
 109                 continue
                     

                     i1 = iae(i,j1)
                     i2 = iae(i,j2)

                     if(i1 .lt. 0) then
                        print *,'ERROR1 in REP_BOUN'
                     else
                        jj1 = 0
                        do ll=1,3
                           if(iae(i1,ll) .eq. i) jj1 = ll
                        enddo
                     endif
                     if(i2 .lt. 0) then
                        print *,'ERROR2 in REP_BOUN'
                     else
                        jj2 = 0
                        do ll=1,3
                           if(iae(i2,ll) .eq. i) jj2 = ll
                        enddo
                     endif
                     if(jj1 .eq. 0) then
                        print *,'ERROR3 in REP_BOUN'
                     else
                        iae(i1,jj1) = -2
                     endif
                     if(jj2 .eq. 0) then
                        print *,'ERROR4 in REP_BOUN'
                     else
                        iae(i2,jj2) = -2
                     endif

                     do 101 l=1,nelem
                        do 111 k=1,3
                           if(iae(l,k) .gt. i) iae(l,k) = iae(l,k)-1
 111                    continue
 101                 continue
                     do 100 l=i,nelem-1
                        do 110 k=1,3
                           lnd(l,k) = lnd(l+1,k)
                           iae(l,k) = iae(l+1,k)
 110                    continue
 100                 continue

                     if(icyc(k1,2) .eq. k2) then
                        do l=1,abs(icyc(k1,1))-1
                           icyc(k1,l+1) = icyc(k1,l+2)
                        enddo
                        icyc(k1,1) = icyc(k1,1) + 1
                     elseif(icyc(k1,abs(icyc(k1,1))+1) .eq. k2)then
                        icyc(k1,1) = icyc(k1,1) + 1
                     else
                        print *,'ERROR k2 is not in the cykle of k1'
                        stop
                     endif
                     if(icyc(k2,2) .eq. k1) then
                        do l=1,abs(icyc(k2,1))-1
                           icyc(k2,l+1) = icyc(k2,l+2)
                        enddo
                        icyc(k2,1) = icyc(k2,1) + 1
                     elseif(icyc(k2,abs(icyc(k2,1))+1) .eq. k1)then
                        icyc(k2,1) = icyc(k2,1) + 1
                     else
                        print *,'ERROR k1 is not in the cykle of k2'
                        stop
                     endif

                     kl1 = 0
                     kl2 = 0
                     do l=1,icyc(k0,1)
                        lock(l) = icyc(k0,l+1)
                        if(lock(l) .eq. k1) kl1 = l
                        if(lock(l) .eq. k2) kl2 = l
                     enddo
                     if(kl1*kl2 .eq. 0) then
                        print *,'k1 and k2 are not in cykle of k0'
                        stop
                     endif

                     if(abs(kl1-kl2) .eq. 1) then
                        if(kl1 .lt. kl2) then
                           do l=1, icyc(k0,1) - kl1
                              icyc(k0,l+1) = lock(kl1+l)
                           enddo
                           do l=1,kl1
                              icyc(k0,icyc(k0,1)-kl1+l+1) = lock(l)
                           enddo
                        else
                           do l=1, icyc(k0,1) - kl2
                              icyc(k0,l+1) = lock(kl2+l)
                           enddo
                           do l=1,kl2
                              icyc(k0,icyc(k0,1)-kl2+l+1) = lock(l)
                           enddo
                        endif
                        icyc(k0,1) = -icyc(k0,1)
                     else
c     all is OK
                        icyc(k0,1) = -icyc(k0,1)
                     endif
                     
c     repair of boundary files
                     do ib=1,nbelm
                        if(itc(ib) .gt. i) itc(ib) = itc(ib) - 1
                     enddo

                     nbelmold = nbelm
                     do 600 ib=1,nbelmold
                        if(lbn(ib,1) .eq. k1 
     *                       .and. lbn(ib,2) .eq. k2) then
                           do ib1=0,nbelm-ib-1
                              lbn(nbelm+1-ib1,1) = lbn(nbelm-ib1,1)
                              lbn(nbelm+1-ib1,2) = lbn(nbelm-ib1,2)
                              ibc(nbelm+1-ib1) = ibc(nbelm-ib1)
                              itc(nbelm+1-ib1) = itc(nbelm-ib1)
                           enddo
                           lbn(ib,2) = k0
                           lbn(ib+1,1) = k0
                           lbn(ib+1,2) = k2
                           ibc(ib+1) = ibc(ib)
                           if(i2.gt.i) then
                              itc(ib) = i2-1
                           else
                              itc(ib) = i2
                           endif
                           if(i1.gt.i) then
                              itc(ib+1) = i1-1
                           else
                              itc(ib+1) = i1
                           endif
                           nbelm = nbelm + 1
                           goto 610
                        endif
 600                 continue
                     print *,'boundary segment doesn''t found'
                     stop
 610                 continue
                     nelem = nelem - 1
                     icha = icha + 1
                  endif
               endif
            endif
 21         continue
 20      continue
         if( i .gt. nelem) goto 2000
         ipoc = ipoc + 1
 10   continue
 2000 continue
      return
      end

      subroutine INSERT(ndim,melem,nelem,mpoin,npoin,
     *     maxdeg,x,y,lnd,iae,
     *     ra,icyc,rminerr,imin,rmaxrez,
     *     icha,nserr,wp,rga,rgb,rgc,lbn,itc,ibc,nbelm,mbelm,
     *     ipoint,nbp,xb,yb,ibb,ibpoin,ibp,ier)
      dimension lnd(melem,3),iae(melem,3),x(mpoin),y(mpoin),
     *     ra(mpoin),wp(mpoin,ndim+1),
     *     lbn(mbelm,2),itc(mbelm),ibc(mbelm),
     *     icyc(mpoin,maxdeg),
     *     nserr(melem*3,2),rga(mpoin),rgb(mpoin),rgc(mpoin),
     *     xb(ipoint),yb(ipoint),ibp(mpoin),ibb(mpoin,2),ibpoin(0:nbp)
      real xx(4),yy(4),rmax(3)
      integer jmax(3)
      common /const/ p, epsilon1, pos, numel,ityp
      common /period/ xper,yper,iper1,iper2

      ier = 0

      icha = 0
      ice = 0

      rlmax2 = 5.33

      do 5 i=1,melem
         nserr(i,1) = 0
 5    continue

      nelemold = nelem
      do 10 ipoc = 1,nelemold
         i = ipoc
         do 20 j=1,3
            j1 = mod(j,3) +1
            ii1 = lnd(i,j)
            ii2 = lnd(i,j1)
            xi = x(ii1)
            yi = y(ii1)
            xi1 = x(ii2)
            yi1 = y(ii2)
            zi = wp(ii1,1)
            zi1 = wp(ii2,1)
            a = (rga(ii1) + rga(ii2) )/2
            b = (rgb(ii1) + rgb(ii2) )/2
            c = (rgc(ii1) + rgc(ii2) )/2
            rmax(j) = ( a*(xi-xi1)*(xi-xi1) + c*(yi-yi1)*(yi-yi1)
     *           +2*b*(xi-xi1)*(yi-yi1))
            jmax(j) = j
 20      continue

         do 25 k=1,3
            do 26 l=1,2
               if(rmax(l) .lt. rmax(l+1) ) then
                  rmaxhelp = rmax(l)
                  rmax(l) = rmax(l+1)
                  rmax(l+1) = rmaxhelp
                  jmaxhelp = jmax(l)
                  jmax(l) = jmax(l+1)
                  jmax(l+1) = jmaxhelp
               endif
 26         continue
 25      continue

         do 28 l=1,3
c     checking the dimension of arrays (even for periodical boundary)
            if(npoin .ge. mpoin-2 .or.nelem .ge. melem-4 .or.
     *           nbelm .ge. mbelm-2 ) then
               print *,'Dimension in insert full'
               print *,'nelem,melem=',nelem,melem
               print *,'npoin,mpoin=',npoin,mpoin
               print *,'nbelm,mbelm=',nbelm,mbelm
               ier = -4
               return
            endif

            if(rmax(l) .ge. rlmax2) then
               j = jmax(l)
               if(iae(i,j) .gt. 0) then
c     for non boundary sides
                  ii = iae(i,j)
                  if(nserr(i,1) .eq. 0 .and. nserr(ii,1) .eq. 0) then
                     j1 = mod(j,3)+1
                     j2 = mod(j1,3)+1
                     do 30 jjj=1,3
                        if(iae(ii,jjj) .eq. i) jj = jjj
 30                  continue
                     jj1 = mod(jj,3)+1
                     jj2 = mod(jj1,3)+1
                     k1 = lnd(i,j)
                     k2 = lnd(i,j1)
                     k3 = lnd(i,j2)
                     k4 = lnd(ii,jj2)
                     if(k2.ne.lnd(ii,jj) .or. k1.ne.lnd(ii,jj1))then
                        print *,'ERRROR in INSERT'
                        print *,i,k1,k2,k3,k4
                     endif
                     
c     check if no validation of positivity
                     xx(1) = x(k1)
                     xx(2) = x(k4)
                     xx(3) = x(k2)
                     xx(4) = x(k3)
                     yy(1) = y(k1)
                     yy(2) = y(k4)
                     yy(3) = y(k2)
                     yy(4) = y(k3)
                     xx0 = (x(k1)+x(k2) )/2
                     yy0 = (y(k1)+y(k2) )/2

                     do 43 kl = 1,4
                        kl1 = mod(kl, 4) + 1
                        reps = pos*( (xx0-xx(kl))**2+(yy0-yy(kl))**2 +
     *                       (xx(kl)-xx(kl1))**2+(yy(kl)-yy(kl1))**2 +
     *                       (xx0-xx(kl1))**2 + (yy0-yy(kl1))**2 )
                        det = xx0*(yy(kl)-yy(kl1)) + 
     *                       xx(kl)*(yy(kl1)-yy0) + xx(kl1)*(yy0-yy(kl))
                        if( det .le. reps) then
c     violation of positivity, go to next j
                           goto 28
                        endif
 43                  continue
                     
                     if(iae(i,j1) .gt. 0) then
                        ia1 = iae(i,j1)
                        do 40 kk =1,3
                           if(iae(ia1,kk) .eq. i) ja1 = kk
 40                     continue
                     else
                        ia1 = -1
                     endif
                     if(iae(i,j2) .gt. 0) then
                        ia2 = iae(i,j2)
                        do 50 kk =1,3
                           if(iae(ia2,kk) .eq. i) ja2 = kk
 50                     continue
                     else
                        ia2 = -1
                     endif
                     if(iae(ii,jj1) .gt. 0) then
                        iia1 = iae(ii,jj1)
                        do 60 kk =1,3
                           if(iae(iia1,kk) .eq. ii) jja1 = kk
 60                     continue
                     else
                        iia1 = -1
                     endif
                     if(iae(ii,jj2) .gt. 0) then
                        iia2 = iae(ii,jj2)
                        do 70 kk =1,3
                           if(iae(iia2,kk) .eq. ii) jja2 = kk
 70                     continue
                     else
                        iia2 = -2
                     endif

                     if(icha .eq. -1) then
                        write(*,'(a2,8i5)') '@@',i,ii,k1,k2,k3,k4,
     *                       npoin,nelem
                     endif
                     x(npoin+1) = (x(k1)+x(k2))/2
                     y(npoin+1) = (y(k1)+y(k2))/2
                     ibb(npoin+1,1) = -1
                     ibb(npoin+1,2) = 0

                     
                     lnd(i,j) = npoin+1
                     iae(i,j2) = nelem+1
                     iae(i,j) = nelem+2
                     lnd(ii,jj) = npoin+1
                     iae(ii,jj2) = nelem+2
                     iae(ii,jj) = nelem+1
                     lnd(nelem+1,1) = npoin+1
                     lnd(nelem+1,2) = k3
                     lnd(nelem+1,3) = k1
                     iae(nelem+1,1) = i
                     iae(nelem+1,2) = ia2
                     iae(nelem+1,3) = ii
                     if(ia2 .gt. 0) then
                        iae(ia2,ja2) = nelem+1
                     else
c     corection of adjacent triangle
                        do ib=1,nbelm
                           if(itc(ib) .eq. i) itc(ib) = nelem+1
                        enddo
                     endif
                     
                     lnd(nelem+2,1) = npoin+1
                     lnd(nelem+2,2) = k4
                     lnd(nelem+2,3) = k2
                     iae(nelem+2,1) = ii
                     iae(nelem+2,2) = iia2
                     iae(nelem+2,3) = i
                     if(iia2 .gt. 0) then
                        iae(iia2,jja2) = nelem+2
                     else
c     corection of adjacent triangle
                        do ib=1,nbelm
                           if(itc(ib) .eq. ii) itc(ib) = nelem+2
                        enddo
                     endif

                     wp(npoin+1,1) = ( wp(k1,1) + wp(k2,1) )/2

                     rga(npoin+1) = (rga(k1) + rga(k2))/2
                     rgb(npoin+1) = (rgb(k1) + rgb(k2))/2
                     rgc(npoin+1) = (rgc(k1) + rgc(k2))/2
                     ibp(npoin+1) = 0
                     
                     npoin = npoin + 1 
                     nelem = nelem + 2
                     icha = icha + 1
                     if(npoin .gt. mpoin .or. nelem .gt. melem) then
                        print *,'Error in dimension in insert'
                        print *,'nelem,melem=',nelem,melem
                        print *,'npoin,mpoin=',npoin,mpoin
                        stop
                     endif
                     
c     ... in each triangle only one division
                     nserr(i,1) = -1
                     nserr(ii,1) = -1
                     nserr(nelem,1) = -1
                     nserr(nelem-1,1) = -1
                     goto 10
                  endif
               else
c     for boundary sides
                  if(nserr(i,1) .eq. 0 )then
                     ipe = 0
 999                 j1 = mod(j,3)+1
                     j2 = mod(j1,3)+1
                     k1 = lnd(i,j)
                     k2 = lnd(i,j1)
                     k3 = lnd(i,j2)
                     ia1 = iae(i,j1)
                     ia2 = iae(i,j2)
                     il0 = -1
                     if(ipe .eq. 1) goto 128
c     for periodic boundary, the second point

c     we seek the poin inthe field [xb(i),yb(i)] i=1,ipoint
                     rll = ((x(k1) - x(k2))*(x(k1) - x(k2)) +
     *                    (y(k1) - y(k2))*(y(k1) - y(k2)) )
                     x0 = (x(k1) + x(k2))/2 
                     y0 = (y(k1) + y(k2))/2 

                     if(ibb(k1,1) .gt. 0 .and. ibb(k2,1) .gt. 0 
     *                    .and. ibb(k1,2) .eq. ibb(k2,2) ) then
                        il1 = ibb(k1,1)
                        il2 = ibb(k2,1)
                        rl0 = 1E+35
                        if( il1 .gt. il2) then
c     0 node id between il1 and il2
                           il2new = il2 + ibpoin(ibb(k1,2))
                        else
                           il2new = il2
                        endif
                        do 213 ll1=il1,il2new
                           ll11 = ll1
                           if(ll11 .gt. ibpoin(ibb(k1,2)) )
     *                          ll11 = ll11 - ibpoin(ibb(k1,2))
                           rlen0 = (x0 -xb(ll11))*(x0 -xb(ll11)) + 
     *                          (y0 -yb(ll11))*(y0 -yb(ll11))
                           if(rlen0 .lt. rl0) then
                              rl0 = rlen0
                              il0 = ll11
                           endif
 213                    continue

                        if(il1 .eq. il0 .or. il2 .eq. il0) then
                           print *,'We can not insert a new node,',
     *                          'there is few points on the profile'
                           print *,il0,il1,il2
                           print *,k1,x(k1),y(k1)
                           print *,k2,x(k2),y(k2)
                           goto 28
                        endif
                        if(rl0 .gt. 0.1*rll) then
                           print *,'very divny',k1,k2
                           print *,x(k1),y(k1)
                           print *,x(k2),y(k2)
                           print *,x0,y0
                           print *,xb(il0),yb(il0)
                           print *,xb(il1),yb(il1)
                           print *,xb(il2),yb(il2)
                           stop
                        endif
                        x0 = xb(il0)
                        y0 = yb(il0)
                     endif
                     

                     reps = pos*( (x0-x(k1))**2+(y0-y(k1))**2 +
     *                    (x(k1)-x(k3))**2+(y(k1)-y(k3))**2 +
     *                    (x0-x(k3))**2 + (y0-y(k3))**2 )
                     det = x(k1)*(y0-y(k3)) + x0*(y(k3)-y(k1)) + 
     *                    x(k3)*(y(k1)-y0)
                     if( det .le. reps ) then
c     violation of positivity, go to next j
                        goto 28
                     endif
                     reps = pos*( (x0-x(k3))**2+(y0-y(k3))**2 +
     *                    (x(k3)-x(k2))**2+(y(k3)-y(k2))**2 +
     *                    (x0-x(k2))**2 + (y0-y(k2))**2 )
                     det = x(k3)*(y0-y(k2)) + x0*(y(k2)-y(k3)) + 
     *                    x(k2)*(y(k3)-y0)
                     if( det .le. reps ) then
c     violation of positivity, go to next j
                        goto 28
                     endif
c     periodic boundary
                     if(ibp(k1) .gt. 0 .and. ibp(k2) .gt. 0 ) then
                        do 1000 iel =1,nelem
                           do 1001 jel=1,3
                              if(iae(iel,jel) .lt. 0 .and.
     *                             lnd(iel,jel) .eq. ibp(k2))goto 1002
 1001                      continue
 1000                   continue
 1002                   continue
                        je1 = mod(jel,3)+1
                        je2 = mod(je1,3)+1
                        ke1 = lnd(iel,jel)
                        ke2 = lnd(iel,je1)
                        ke3 = lnd(iel,je2)
                        if(abs(x(k2) + xper - x(ke1) ) .lt. 1E-05 .and.
     *                       abs(y(k2)+yper-y(ke1) ) .lt. 1E-05 ) then
                           imov = 1
                        elseif(abs(x(k2)-xper-x(ke1)) .lt. 1E-05 .and.
     *                          abs(y(k2)-yper-y(ke1)).lt. 1E-05 ) then
                           imov = -1
                        else
                           print *,'BAD in insert in periodical points'
                           print *,i,k2,ke1
                           print *,x(k2),y(k2),xper
                           print *,x(ke1),y(ke1),yper
                           print *,abs(x(k2) + xper - x(ke1) ),
     *                          abs(y(k2) + yper - y(ke1) ),
     *                          abs(x(k2) - xper - x(ke1) ),
     *                          abs(y(k2) - yper - y(ke1) )
                           stop
                        endif
                        
                        xe0 = x0 + imov*xper
                        ye0 = y0 + imov*yper

                        reps = pos*( (xe0-x(ke1))**2+(ye0-y(ke1))**2 +
     *                       (x(ke1)-x(ke3))**2+(y(ke1)-y(ke3))**2 +
     *                       (xe0-x(ke3))**2 + (ye0-y(ke3))**2 )
                        det = x(ke1)*(ye0-y(ke3)) + xe0*(y(ke3)-y(ke1))
     *                       + x(ke3)*(y(ke1)-ye0)
                        if( det .le. reps ) then
c     violation of positivity, go to next j
                           goto 28
                        endif
                        reps = pos*( (xe0-x(ke3))**2+(ye0-y(ke3))**2 +
     *                       (x(ke3)-x(ke2))**2+(y(ke3)-y(ke2))**2 +
     *                       (xe0-x(ke2))**2 + (ye0-y(ke2))**2 )
                        det = x(ke3)*(ye0-y(ke2)) + xe0*(y(ke2)-y(ke3))
     *                       + x(ke2)*(y(ke3)-ye0)
                        if( det .le. reps ) then
c     violation of positivity, go to next j
                           goto 28
                        endif
                     endif

 128                 continue

                     if(ia1 .gt. 0) then
                        ja1 = 0
                        do 125 ll=1,3
                           if(iae(ia1,ll) .eq. i) then
                              ja1 = ll
                           endif
 125                    continue
                        if(ja1 .eq. 0) then 
                           print *,'ERROR in INSERT_BOUNDARY-1'
                           stop
                        endif
                     endif

                     if(ipe .eq. 0) then
                        x(npoin+1) = x0
                        y(npoin+1) = y0
                        ibb(npoin+1,1) = il0
                     elseif(ipe .eq. 1) then
                        x(npoin+1) = xe0
                        y(npoin+1) = ye0
                        ibb(npoin+1,1) = il0
                     else
                        print *,'bad value of ipe =',ipe
                     endif

                     if(ibb(k1,2) .eq. 0 .or. ibb(k2,2) .eq. 0) then
                        ibb(npoin+1,2) = 0
                     elseif(ibb(k1,2) .eq. ibb(k2,2)) then
                        ibb(npoin+1,2) = ibb(k1,2)
                     else
c                        print *,'error jkol1'
                     endif


                     wp(npoin+1,1) = (wp(k1,1) + wp(k2,1))/2
                     rga(npoin+1) = (rga(k1) + rga(k2))/2
                     rgb(npoin+1) = (rgb(k1) + rgb(k2))/2
                     rgc(npoin+1) = (rgc(k1) + rgc(k2))/2
                     
                     lnd(i,j1) = npoin+1
                     iae(i,j1) = nelem+1

                     lnd(nelem+1,1) = npoin+1
                     lnd(nelem+1,2) = k2
                     lnd(nelem+1,3) = k3
                     iae(nelem+1,1) = -2
                     iae(nelem+1,2) = ia1
                     iae(nelem+1,3) = i

                     if(ia1 .gt. 0) iae(ia1,ja1) = nelem+1

c     the change in lbn, nbc,itc
                     ib1 = 0
                     do 265 ib=1,nbelm
                        if(lbn(ib,1) .eq. k1 .and.lbn(ib,2) .eq. k2)then
                           ib1 = ib
                           goto 266
                        endif
 265                 continue
 266                 continue
                     if(ib1 .eq. 0 ) then
                        print *,'ERROR in INSERT'
                        print *,'the boundary segment does not found'
                        stop
                     endif
                     
                     do 276 ii=1,nbelm-ib1
                        ib = nbelm +2 -ii
                        lbn(ib,1) = lbn(ib-1,1)
                        lbn(ib,2) = lbn(ib-1,2)
                        ibc(ib) = ibc(ib-1)
                        itc(ib) = itc(ib-1)
 276                 continue
                     

                     lbn(ib1,2) = npoin + 1
                     lbn(ib1+1,1) = npoin + 1
                     lbn(ib1+1,2) = k2
                     ibc(ib1+1) = ibc(ib1)
                     itc(ib1+1) = nelem+1
                     if(ipe .eq. 0) ibp(npoin+1) = 0


                     npoin = npoin + 1
                     nelem = nelem + 1
                     nbelm = nbelm + 1

                     if(npoin .gt. mpoin .or.nelem .gt. melem .or.
     *                    nbelm .gt. mbelm ) then
                        print *,'ERROR in dimension in insert'
                        print *,'nelem,melem=',nelem,melem
                        print *,'npoin,mpoin=',npoin,mpoin
                        print *,'nbelm,mbelm=',nbelm,mbelm
                        stop
                     endif
                     
                     nserr(i,1) = -1
                     nserr(nelem,1) = -1
                     if( ibp(k1) .gt. 0 .and. ibp(k2) .gt. 0 .and. 
     *                    ipe .eq. 0) then
                        jbak = j
                        i = iel
                        j = jel
                        ibp(npoin) = npoin + 1
                        ibp(npoin+1) = npoin
                        ipe = 1
                        goto 999
                     endif 
                     if(ipe .eq. 1) then
                        ipe = 0
                        i = ipoc
                        j = jbak
                     endif
                     icha = icha + 1
                     goto 10
                  endif
               endif
            endif
 28      continue
 10   continue
 11   continue
      return
      end
