      subroutine REM_BOUND(ndim,melem,nelem,mpoin,npoin,
     *     maxdeg,x,y,lnd,iae,
     *     ra,icyc,rminerr,imin,rmaxrez,
     *     icha,nserr,wp,lbn,itc,ibc,nbelm,mbelm,
     *     rga,rgb,rgc,ibp,ibb,ibpoin,ipoint,nbp)
      dimension lnd(melem,3),iae(melem,3),x(mpoin),y(mpoin),
     *     ra(mpoin),wp(mpoin,ndim+1),rga(mpoin),rgb(mpoin),rgc(mpoin),
     *     icyc(mpoin,maxdeg),
     *     nserr(melem*3,2),lbn(mbelm,2),itc(mbelm),
     *     ibc(mbelm),ibp(mpoin),ibb(mpoin,2),ibpoin(0:nbp)
      integer nsr(3),locyc(30)

      common /const/ p, epsilon1, pos, numel,ityp
      common /period/ xper,yper,iper1,iper2

      icha = 0
      ipoc = 0
 10   ipoc = ipoc + 1

      i = ipoc
      if(ibb(i,1) .gt.0 ) then
         ikk1 = ibb(i,2)
         if(ibb(i,1) .eq. ibpoin(ikk1-1)+1  .or.
     *        ibb(i,1) .eq. ibpoin(ikk1)) then
c     no removing, initial or final point of profiles
            goto 10
         endif
      endif       
      if(icyc(i,1) .eq. -3 ) then
         i0 = icyc(i,2)
         i1 = icyc(i,3)
         i2 = icyc(i,4)
         if(icyc(i1,1) .lt. 0) goto 101
         det = x(i0)*(y(i)-y(i2)) + x(i)*(y(i2)-y(i0)) + 
     *        x(i2)*(y(i0)-y(i))

         rep =  ((x(i0)-x(i))**2 + (y(i0)-y(i))**2) +
     *        ((x(i)-x(i2))**2 + (y(i)-y(i2))**2) +
     *        ((x(i2)-x(i0))**2 + (y(i2)-y(i0))**2) 

         if (abs(det)/rep .lt. 1e-02) then
c                  the points i0, i, i2 are in the straight, 
c                  we can remove one triangle

            det = x(i0)*(y(i1)-y(i2)) + x(i1)*(y(i2)-y(i0)) + 
     *           x(i2)*(y(i0)-y(i1))
            reps = pos*( ((x(i0)-x(i1))**2 + (y(i0)-y(i1))**2) +
     *              ((x(i1)-x(i2))**2 + (y(i1)-y(i2))**2) +
     *              ((x(i2)-x(i0))**2 + (y(i2)-y(i0))**2) )
            if( det .le. reps ) then
c               print *,'violation of positivity'
               goto 100
            endif
            ibo = 0
            call QUA2(x(i0),y(i0),wp(i0,1),rga(i0),rgb(i0),rgc(i0),
     *           x(i1),y(i1),wp(i1,1),rga(i1),rgb(i1),rgc(i1),
     *           x(i2),y(i2),wp(i2,1),rga(i2),rgb(i2),rgc(i2),
     *           err0,errrez0,ice,ibo)
            call QUA2(x(i0),y(i0),wp(i0,1),rga(i0),rgb(i0),rgc(i0),
     *           x(i1),y(i1),wp(i1,1),rga(i1),rgb(i1),rgc(i1),
     *           x(i),y(i),wp(i,1),rga(i),rgb(i),rgc(i),
     *           err2,errrez1,ice,ibo)
            call QUA2(x(i),y(i),wp(i,1),rga(i),rgb(i),rgc(i),
     *           x(i1),y(i1),wp(i1,1),rga(i1),rgb(i1),rgc(i1),
     *           x(i2),y(i2),wp(i2,1),rga(i2),rgb(i2),rgc(i2),
     *           err1,errrez2,ice,ibo)
            
            iyes = 0
            if( 1.8*errrez0 .lt. errrez1 + errrez2) then
               iyes = 1
            endif

            if(ibp(i) .gt. 0 .and. iyes .eq. 1) then
               k=ibp(i)
               kik = k
               if(icyc(k,1) .ne. -3) goto 100
               k0 = icyc(k,2)
               k1 = icyc(k,3)
               k2 = icyc(k,4)
               if(icyc(k1,1) .lt. 0) goto 100
               det = x(k0)*(y(k)-y(k2)) + x(k)*(y(k2)-y(k0)) + 
     *              x(k2)*(y(k0)-y(k))
               rep =  ((x(k0)-x(k))**2 + (y(k0)-y(k))**2) +
     *              ((x(k)-x(k2))**2 + (y(k)-y(k2))**2) +
     *              ((x(k2)-x(k0))**2 + (y(k2)-y(k0))**2) 

               if (abs(det)/rep .lt. 1e-02) then
c     the points k0, k, k2 are in the straight, 
c     we can remove one triangle

                  det = x(k0)*(y(k1)-y(k2)) + x(k1)*(y(k2)-y(k0)) + 
     *                 x(k2)*(y(k0)-y(k1))
                  reps = pos*( ((x(k0)-x(k1))**2 + (y(k0)-y(k1))**2) +
     *                 ((x(k1)-x(k2))**2 + (y(k1)-y(k2))**2) +
     *                 ((x(k2)-x(k0))**2 + (y(k2)-y(k0))**2) )
                  if( det .le. reps ) then
c     print *,'violation of positivity'
                     goto 100
                  endif
                  ibo = 0
                  call QUA2(x(k0),y(k0),wp(k0,1),
     *                 rga(k0),rgb(k0),rgc(k0),
     *                 x(k1),y(k1),wp(k1,1),rga(k1),rgb(k1),rgc(k1),
     *                 x(k2),y(k2),wp(k2,1),rga(k2),rgb(k2),rgc(k2),
     *                 err0,errrez0,ice,ibo)
                  call QUA2(x(k0),y(k0),wp(k0,1),
     *                 rga(k0),rgb(k0),rgc(k0),
     *                 x(k1),y(k1),wp(k1,1),rga(k1),rgb(k1),rgc(k1),
     *                 x(k),y(k),wp(k,1),rga(k),rgb(k),rgc(k),
     *                 err2,errrez1,ice,ibo)
                  call QUA2(x(k),y(k),wp(k,1),rga(k),rgb(k),rgc(k),
     *                 x(k1),y(k1),wp(k1,1),rga(k1),rgb(k1),rgc(k1),
     *                 x(k2),y(k2),wp(k2,1),rga(k2),rgb(k2),rgc(k2),
     *                 err1,errrez2,ice,ibo)
            

                  if( 1.8*errrez0 .lt. errrez1 + errrez2 ) then
                     iyes = 2
                  else
                     iyes = 0
                  endif
               endif  
            endif

            if( iyes .ge. 1) then
c     better quality, we  remove a boundary points
 999           i0 = icyc(i,2)
               i1 = icyc(i,3)
               i2 = icyc(i,4)
               itest = 0
               do 20 kk=1,nelem
                  do 30 j=1,3
                     j1 = mod(j,3) + 1
                     j2 = mod(j1,3) + 1
                     if(lnd(kk,j) .eq. i0 .and. lnd(kk,j1) .eq. i1 .and.
     *                    lnd(kk,j2) .eq. i) then
                        k1 = kk
                        kj1 = j
                        kj2 = j1
                        kj3 = j2
                        itest = itest + 1
                     endif
                     if(lnd(kk,j) .eq. i2 .and. lnd(kk,j1) .eq. i .and.
     *                    lnd(kk,j2) .eq. i1) then
                        k2 = kk
                        kjj1 = j
                        kjj2 = j1
                        kjj3 = j2
                        itest = itest + 1
                     endif
                     if(itest .eq. 2) goto 25
 30               continue
 20            continue
 25            continue

               ka1 = iae(k1,kj1)
               if(ka1 .gt. 0) then
                  do 40 j=1,3
                     if(iae(ka1,j) .eq. k1) ka1j = j
 40               continue
               endif
               ka2 = iae(k2,kjj3)
               if(ka2 .gt. 0) then
                  do 45 j=1,3
                     if(iae(ka2,j) .eq. k2) ka2j = j
 45               continue
               endif


               lnd(k1,kj3) = i2
               iae(k1,kj2) = ka2
               if(ka2 .gt. 0) iae(ka2,ka2j) = k1

               do ie = 1,nelem
                  do j=1,3
                     if(iae(ie,j) .eq. nelem .and. k2 .ne. nelem) 
     *                    iae(ie,j) = k2
                     if(lnd(ie,j) .eq. npoin) lnd(ie,j) = i
                  enddo
               enddo

               do 70 ij =1,3
                  if(k2 .ne. nelem) then
                     lnd(k2,ij) = lnd(nelem,ij)
                     iae(k2,ij) = iae(nelem,ij)
                  endif
 70            continue

               
               if (kik .eq. npoin) kik = i
               
               x(i) = x(npoin)
               y(i) = y(npoin)
               ibb(i,1) = ibb(npoin,1)
               ibb(i,2) = ibb(npoin,2)
               rga(i) = rga(npoin)
               rgb(i) = rgb(npoin)
               rgc(i) = rgc(npoin)
               wp(i,1) = wp(npoin,1)
               ibp(i) = ibp(npoin)
               do iy=1,npoin
                  if(ibp(iy) .eq. npoin) ibp(iy) = i
               enddo
                  

               icyc(i0,abs(icyc(i0,1))+1) = i2
               icyc(i2,2) = i0
               do 200 k=1,icyc(i1,1)
                  if(icyc(i1,k+1) .eq. i) then
                     kk = k
                     goto 210
                  endif
 200           continue
 210           continue

               do 220 k=kk,icyc(i1,1)-1
                  icyc(i1,k+1) = icyc(i1,k+2)
 220           continue
               icyc(i1,1) = icyc(i1,1) - 1

               do is = 1,npoin
                  do j=1,abs(icyc(is,1))
                     if(icyc(is,j+1) .eq. npoin)icyc(is,j+1) =i
                  enddo
               enddo  
               
               do 260 j=1,abs(icyc(npoin,1))+1
                  icyc(i,j)=icyc(npoin,j)
 260           continue



c     reparation of lbn, ibc, itc
               do ib=1,nbelm
                  if(lbn(ib,2) .eq. i) then
                     lbn(ib,2) = i0
                     itc(ib) = k1
                     ibstart1 = ib
                  elseif(lbn(ib,1) .eq. i) then
                     ibstart2 = ib
                  endif
               enddo

c               print *,'ibstart =',ibstart1,ibstart2


               do 698 ib=1,nbelm
                  if(lbn(ib,1) .eq. npoin) lbn(ib,1) = i
                  if(lbn(ib,2) .eq. npoin) lbn(ib,2) = i
 698           continue
               do 710 ib1 = ibstart2,nbelm-1
                  lbn(ib1,1) = lbn(ib1+1,1)
                  lbn(ib1,2) = lbn(ib1+1,2)
                  ibc(ib1) = ibc(ib1+1)
                  itc(ib1) = itc(ib1+1)
 710           continue
               do ib1 = 1,nbelm-1
                  if(itc(ib1) .eq. nelem) then
                     itc(ib1) = k2
                  endif
               enddo

               nbelm = nbelm - 1
               nelem = nelem - 1
               npoin = npoin - 1

               icha = icha + 1


               if(iyes .eq. 2) then
                  iyes = 3
                  i = kik
                  goto 999
               endif
            endif
 100        continue
         endif
 101     continue
      endif
      if(ipoc .lt. npoin) goto 10
      return
      end
