      subroutine SWAPPING(ndim, melem,nelem,mpoin,npoin,
     *     x,y,lnd,iae,icha,
     *     ra,wp,rga,rgb,rgc,iba,nbelm,mbelm,lbn,ibc,itc,
     *     maxdeg,icyc,ibp)
      dimension lnd(melem,3),iae(melem,3),x(mpoin),y(mpoin),
     *     lbn(mbelm,2),ibc(mbelm),itc(mbelm),
     *     ra(melem*3),wp(mpoin,ndim+1), 
     *     icyc(mpoin,maxdeg),ibp(mpoin),
     *     rga(mpoin),rgb(mpoin),rgc(mpoin)
      integer iba(melem,3)
      real *8 x1,y1,x2,y2,x3,y3,x4,y4,reps123,reps134,det123,det134

      common /const/ p, epsilon1, pos, numel,ityp
      common /period/ xper,yper,iper1,iper2


      do i=1,nelem
         do j=1,3
            iba(i,j) = 0
         enddo
      enddo

      ice = 0
      icha = 0
      do 10 i=1,nelem
         do 20 j=1,3
            if(iae(i,j) .gt. 0 .and. iba(i,j) .eq. 0) then
               j1 = mod(j,3) +1
               j2 = mod(j1,3) +1
               ii = iae(i,j)
               do 30 jjj=1,3
                  if(lnd(ii,jjj) .eq. lnd(i,j1)) jj = jjj
 30            continue
               iba(i,j) = 1
               iba(ii,jj) = 1
               jj1 = mod(jj,3) +1
               j0 = mod(jj1,3) +1
               k1 = lnd(i,j2)
               k2 = lnd(i,j)
               k3 = lnd(ii,j0)
               k4 = lnd(i,j1)
               if( k2 .ne. lnd(ii,jj1) .or. k4 .ne. lnd(ii,jj) ) then
                  print *,'ERROR !@#'
                  print *,k1,k2,k3,k4
                  return
               endif
               x1 = x(k1)
               y1 = y(k1)
               x2 = x(k2)
               y2 = y(k2)
               x3 = x(k3)
               y3 = y(k3)
               x4 = x(k4)
               y4 = y(k4)
               w1 = wp(k1,1)
               w2 = wp(k2,1)
               w3 = wp(k3,1)
               w4 = wp(k4,1)

c     we prohibid SWAPPING in case, where can appear alement with two
c     boundary segment
               if( (iae(i,j2) .lt. 0 .and. iae(ii,jj1) .lt. 0 ) .or.
     *              (iae(i,j1) .lt. 0 .and. iae(ii,j0) .lt. 0) ) then
                  goto 20
               endif
c     we must still chech the orientation, i.e. the  cykles of points
c     k1,k2,k4 and k1,k4,k3 must have positive orientation

               det123 = x1*(y2-y3) + x2*(y3-y1) + x3*(y1-y2)
               det134 = x1*(y3-y4) + x3*(y4-y1) + x4*(y1-y3) 

               reps123 = pos*( ((x1-x3)**2 + (y1-y3)**2) +
     *              ((x2-x3)**2 + (y2-y3)**2) +
     *              ((x1-x2)**2 + (y1-y2)**2) )
               reps134 = pos*( ((x1-x3)**2 + (y1-y3)**2) +
     *              ((x4-x3)**2 + (y4-y3)**2) +
     *              ((x1-x4)**2 + (y1-y4)**2) )
               if( det123 .le. reps123 .or. det134 .le. reps134) then
c                  print *,'violation of positivity'
                  goto 20
               endif

               ice = 0

               epsround = 5E-03

               rl13 = ( (rga(k1)+rga(k3))*(x1-x3)*(x1-x3) +
     *              2*(rgb(k1)+rgb(k3))*(x1-x3)*(y1-y3)  +
     *              (rgc(k1)+rgc(k3))*(y1-y3)*(y1-y3) )/2

               rl24 = ( (rga(k2)+rga(k4))*(x2-x4)*(x2-x4) +
     *              2*(rgb(k2)+rgb(k4))*(x2-x4)*(y2-y4)  +
     *              (rgc(k2)+rgc(k4))*(y2-y4)*(y2-y4) )/2


               if(abs(rl13 - 3.) .lt. 0.995 * abs(rl24 -3.) )then

c        ... we use a SWAPPING
                  itci = 0
                  itcii = 0

                  iyii = iae(ii,jj1)
                  if(iyii .gt. 0) then
                     do 62 iy=1,3
                        if( iae(iyii,iy) .eq. ii) then
                           iyiij = iy
                        endif
 62                  continue
                  else
c     boundary segment, we seek itc
                     do ib1 =1,nbelm
                        if(itc(ib1) .eq. ii) then
                           itci = ib1
                           goto 662
                        endif
                     enddo
                     print *,'boundary segment in SWAPPING for itc not'
                     stop
                  endif
 662              continue

                  iyi = iae(i,j1)
                  if(iyi .gt. 0) then
                     do 63 iy=1,3
                        if( iae(iyi,iy) .eq. i) then
                           iyij = iy
                        endif
 63                  continue
                  else
                     do ib1 =1,nbelm
                        if(itc(ib1) .eq. i) then
                           itcii = ib1
                           goto 663
                        endif
                     enddo
                     print *,'boundary segment in SWAPPING for itc not2'
                     stop
                  endif
 663              continue
                  if(itci .gt. 0) itc(itci) = i
                  if(itcii .gt. 0) itc(itcii) = ii
                  
                  lnd(i,j1) = k3
                  lnd(ii,jj1) = k1
                  
                  iae(i,j) = iyii
                  iae(i,j1) = ii
                  if(iyii .gt.0 ) iae(iyii,iyiij) = i

                  iae(ii,jj) = iyi
                  iae(ii,jj1) = i
                  if(iyi .gt.0 ) iae(iyi,iyij) = ii
                  icha = icha+1
               endif
            endif
 20      continue
 10   continue

      return
      end
